# finscraper

[![Build Status](https://travis-ci.com/jmyrberg/finscraper.svg?branch=master)](https://travis-ci.com/jmyrberg/finscraper) [![Documentation Status](https://readthedocs.org/projects/finscraper/badge/?version=latest)](https://finscraper.readthedocs.io/en/latest/?badge=latest)

![finscraper cover](https://github.com/jmyrberg/finscraper/blob/master/docs/cover.jpg?raw=true)

The library provides an easy-to-use API for fetching data from various Finnish websites:

| Website                                                        | Type              | Spider API class   |
| -------------------------------------------------------------- | ----------------- | ------------------ |
| [Ilta-Sanomat](https://www.is.fi)                              | News article      | `ISArticle`        |
| [Iltalehti](https://www.il.fi)                                 | News article      | `ILArticle`        |
| [YLE Uutiset](https://www.yle.fi/uutiset)                      | News article      | `YLEArticle`       |
| [Demi](https://demi.fi)                                        | Discussion thread | `DemiPage`         |
| [Suomi24](https://keskustelu.suomi24.fi)                       | Discussion thread | `Suomi24Page`      |
| [Vauva](https://www.vauva.fi)                                  | Discussion thread | `VauvaPage`        |
| [Oikotie Asunnot](https://asunnot.oikotie.fi/myytavat-asunnot) | Apartment ad      | `OikotieApartment` |
| [Tori](https://www.tori.fi)                                    | Item deal         | `ToriDeal`         |

Documentation is available at [https://finscraper.readthedocs.io](https://finscraper.readthedocs.io) and [simple online demo here](https://storage.googleapis.com/jmyrberg/index.html#/demo-projects/finscraper).


## Installation

`pip install finscraper`


## Quickstart

Fetch 10 news articles as a pandas DataFrame from [Ilta-Sanomat](https://is.fi):

```python
from finscraper.spiders import ISArticle

spider = ISArticle().scrape(10)

articles = spider.get()
```

The API is similar for all the spiders:

![Finscraper in action](https://github.com/jmyrberg/finscraper/blob/master/docs/finscraper.gif)


## Contributing

Please see [CONTRIBUTING.md](https://github.com/jmyrberg/finscraper/blob/master/CONTRIBUTING.md) for more information.


---

Jesse Myrberg (jesse.myrberg@gmail.com)
